"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.getCountry = void 0;
var Reader = require("@maxmind/geoip2-node").Reader;
var fs = require("fs");
var path = __importStar(require("path"));
var geoReader;
var localDbName = "GeoLite2-Country.mmdb";
var remoteDbName = "RemoteGeoLite2-Country.mmdb";
var downloadDb = function () { return __awaiter(void 0, void 0, void 0, function () {
    var https, file;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!process.env.GEO_DB_URL) {
                    console.log("No GEO_DB_URL environment variable found, using local file");
                    return [2 /*return*/];
                }
                https = require("https");
                file = fs.createWriteStream(path.join(__dirname, remoteDbName));
                return [4 /*yield*/, new Promise(function (resolve, reject) {
                        https.get(process.env.GEO_DB_URL, function (response) {
                            response.pipe(file);
                            file.on("finish", function () {
                                file.close();
                                console.log("Finished downloading GEO DB");
                                console.log("File size: ".concat(fs.statSync(path.join(__dirname, remoteDbName)).size));
                                resolve();
                            });
                        }).on("error", function (err) {
                            fs.unlink(path.join(__dirname, remoteDbName));
                            reject(err.message);
                        });
                    })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var loadReader = function () { return __awaiter(void 0, void 0, void 0, function () {
    var remoteDbPath, dbPath;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (geoReader) {
                    return [2 /*return*/, geoReader];
                }
                return [4 /*yield*/, downloadDb()];
            case 1:
                _a.sent();
                remoteDbPath = path.join(__dirname, remoteDbName);
                if (!fs.existsSync(remoteDbPath)) return [3 /*break*/, 3];
                return [4 /*yield*/, Reader.open(remoteDbPath)];
            case 2:
                geoReader = _a.sent();
                return [2 /*return*/, geoReader];
            case 3:
                dbPath = path.join(__dirname, localDbName);
                return [4 /*yield*/, Reader.open(dbPath)];
            case 4:
                geoReader = _a.sent();
                return [2 /*return*/, geoReader];
        }
    });
}); };
var getCountry = function (ip) { return __awaiter(void 0, void 0, void 0, function () {
    var reader;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, loadReader()];
            case 1:
                reader = _a.sent();
                return [2 /*return*/, reader.country(ip)];
        }
    });
}); };
exports.getCountry = getCountry;
var handler = function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var forwardedFor, ips, ip, geo, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                forwardedFor = req.headers["x-forwarded-for"];
                ips = forwardedFor ? forwardedFor.split(",") : [];
                ip = ips[0] || req.connection.remoteAddress;
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, getCountry(ip)];
            case 2:
                geo = _a.sent();
                res.status(200).json({
                    lang: geo.country.names.en === "Vietnam" ? "vi" : "en",
                    info: __assign({ ip: ip })
                });
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                console.error(err_1);
                res.status(200).json({
                    lang: "en",
                    info: __assign({ ip: ip }, { err: err_1 })
                });
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); };
exports.handler = handler;
